//+------------------------------------------------------------------
//| original by Metatrader4 Code by jjk2.                            
//| modified by mladen
//+------------------------------------------------------------------
#property copyright "Based on MBA Thesis from Simon Fraser University written by C.E. ALDEA."
#property link      ""

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//
//
//
//
//

extern string TimeFrame                = "Current time frame";
extern int    Kperiod                  = 9;
extern int    Dperiod                  = 6;
extern int    slowing                  = 2;
extern int    method_stoch             = MODE_SMA;
extern int    price_field              = 1;
extern int    mode                     = 0;
extern int    period_rsi               = 9;
extern int    period_momentum          = 9;
extern string separator2               = "Indicator Settings";
extern bool   drawDivergences          = true;
extern bool   drawIndicatorTrendLines  = true;
extern bool   drawPriceTrendLines      = true;
extern int    arrowSize                = 1; 
extern string drawLinesIdentificator   = "Kwandiverge1";
extern bool   displayAlert             = true;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsEmail              = false;

//
//
//
//
//

double bullishDivergence[];
double bearishDivergence[];
double kwan[];
double kwanDa[];
double kwanDb[];
double temp[];
double slope[];

//
//
//
//
//

static datetime lastAlertTime;
string indicatorName;
string labelNames;

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
double pipMultiplier = 1;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,bullishDivergence); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1,bearishDivergence); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);  
   SetIndexBuffer(2,kwan);
   SetIndexBuffer(3,kwanDa);
   SetIndexBuffer(4,kwanDb);
   SetIndexBuffer(5,temp);
   SetIndexBuffer(6,slope);

       //
       //
       //
       //
       //
      
       labelNames    = "Kwan DivergenceLine "+drawLinesIdentificator+":";
       indicatorName = "Kwan Divergence";
       IndicatorShortName(indicatorName);
   
       //
       //
       //
       //
       //
         
       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
   
return(0);
}

//
//
//
//
//

int deinit()
{
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }
     
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1; 
   
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { bullishDivergence[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (slope[limit]==-1) CleanPoint(limit,kwanDa,kwanDb);
      for (i=limit; i>= 0; i--)
      {
         double Stoch  = iStochastic(NULL,0,Kperiod,Dperiod,slowing,method_stoch,price_field,mode,i);
         double RSI    = iRSI(NULL,0,period_rsi,PRICE_CLOSE,i);
         double moment = iMomentum(NULL,0,period_momentum,PRICE_CLOSE,i);
         if (moment!=0)
               temp[i] = Stoch*RSI/moment;
         else  temp[i] = 0;       
      }
      for (i=limit; i>= 0; i--)
      {
         kwanDa[i] = EMPTY_VALUE;
         kwanDb[i] = EMPTY_VALUE;
         kwan[i]   = iMAOnArray(temp,0,2,0,MODE_SMA,i);
         slope[i]  = slope[i+1];
            if (kwan[i] > kwan[i+1]) slope[i] =  1;
            if (kwan[i] < kwan[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,kwanDa,kwanDb,kwan);
            if (drawDivergences)
             {
               CatchBullishDivergence(i);
               CatchBearishDivergence(i);
             }                     
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
         
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,kwanDa,kwanDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,"",drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,arrowSize,drawLinesIdentificator,displayAlert,alertsMessage,alertsSound,alertsEmail,6,y);
         kwan[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,"",drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,arrowSize,drawLinesIdentificator,displayAlert,alertsMessage,alertsSound,alertsEmail,2,y);
         kwanDa[i] = EMPTY_VALUE;
         kwanDb[i] = EMPTY_VALUE;
         if (slope[i]==-1) PlotPoint(i,kwanDa,kwanDb,kwan);
            
      int firstBar = iBarShift(NULL,0,iTime(NULL,timeFrame,y));
         if (i==firstBar)
         {
           bullishDivergence[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,"",drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,arrowSize,drawLinesIdentificator,displayAlert,alertsMessage,alertsSound,alertsEmail,0,y);
           bearishDivergence[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Kperiod,Dperiod,slowing,method_stoch,price_field,mode,period_rsi,period_momentum,"",drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,arrowSize,drawLinesIdentificator,displayAlert,alertsMessage,alertsSound,alertsEmail,1,y);
         }
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

void CatchBullishDivergence(int shift)
{
   if (drawDivergences)
   {
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow = GetIndicatorLastLow(shift+1);

   //
   //
   //
   //
   //
    
   if(kwan[currentLow] > kwan[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = kwan[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines     == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Green,STYLE_SOLID);
      if(drawIndicatorTrendLines == true)
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],kwan[currentLow],kwan[lastLow],Green,STYLE_SOLID);
      if(displayAlert == true)
                 DisplayAlert("Classical bullish divergence on: ",currentLow);  
                        
   }
     
   //
   //
   //
   //
   //
        
   if(kwan[currentLow] < kwan[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = kwan[currentLow] - Point*pipMultiplier;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Green,STYLE_DOT);
      if(drawIndicatorTrendLines == true)                            
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],kwan[currentLow], kwan[lastLow],Green,STYLE_DOT);
      if(displayAlert == true)
                 DisplayAlert("Reverse bullish divergence on: ",currentLow); 
   }
}
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   if (drawDivergences)
   {
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift+1);

   //
   //
   //
   //
   //
      
   if(kwan[currentPeak] < kwan[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = kwan[currentPeak] + Point*pipMultiplier;
       if(drawPriceTrendLines     == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_SOLID);
       if(drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],kwan[currentPeak],kwan[lastPeak],Red,STYLE_SOLID);
       if(displayAlert            == true)
               DisplayAlert("Classical bearish divergence on: ",currentPeak); 
                        
   }
   
   //
   //
   //
   //
   //

   if(kwan[currentPeak] > kwan[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = kwan[currentPeak] + Point*pipMultiplier;
      if (drawPriceTrendLines     == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_DOT);
      if (drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],kwan[currentPeak],kwan[lastPeak],Red,STYLE_DOT);
      if(displayAlert             == true)
               DisplayAlert("Reverse bearish divergence on: ",currentPeak);
     }                    
   }   
}

//+------------------------------------------------------------------+
//
//
//
//

bool IsIndicatorPeak(int shift)
  {
   if(kwan[shift] >= kwan[shift+1] && kwan[shift] > kwan[shift+2] && kwan[shift] > kwan[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool IsIndicatorLow(int shift)
{
   if(kwan[shift] <= kwan[shift+1] && kwan[shift] < kwan[shift+2] && kwan[shift] < kwan[shift-1])
       return(true);
   else 
       return(false);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastPeak(int shift)
  {
           for(int i = shift+5; i < Bars; i++)
             {
               if(kwan[i] >= kwan[i+1] && kwan[i] > kwan[i+2] && kwan[i] >= kwan[i-1] && kwan[i] > kwan[i-2])
                   return(i);
             }
return(-1);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastLow(int shift)
{
   for(int i = shift+5; i < Bars; i++)
   {
      if(kwan[i] <= kwan[i+1] && kwan[i] < kwan[i+2] && kwan[i] <= kwan[i-1] && kwan[i] < kwan[i-2])
      return(i);
   }
     
return(-1);
}

//
//
//
//
//

void DisplayAlert(string message, int shift)
{
   if(shift <= 2 && Time[shift] != lastAlertTime)
     {
       lastAlertTime = Time[shift];
       if (alertsMessage) Alert(Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Kwan "+message);
       if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Kwan"),message);
       if (alertsSound)   PlaySound("alert2.wav");
       
       
     }
}

//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string label = labelNames+first+"os"+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(indicatorName);
   if (indicatorWindow < 0) return;
   
   string label = labelNames+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}